Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -12,4 +12,5 @@
 #include "boundary.hpp"
 #include "linkedcell.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "element.hpp"
Index: src/Actions/MoleculeAction/BondFileAction.cpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/Actions/MoleculeAction/BondFileAction.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -24,4 +24,5 @@
 #include "config.hpp"
 #include "defs.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -22,4 +22,5 @@
 #include "boundary.hpp"
 #include "config.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "config.hpp"
Index: src/ConfigFileBuffer.cpp
===================================================================
--- src/ConfigFileBuffer.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/ConfigFileBuffer.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -9,4 +9,5 @@
 #include "helpers.hpp"
 #include "lists.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "World.hpp"
Index: src/Parser/PcpParser.cpp
===================================================================
--- src/Parser/PcpParser.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/Parser/PcpParser.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -7,4 +7,5 @@
 
 #include <iostream>
+#include <iomanip>
 
 #include "atom.hpp"
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/UIElements/Dialog.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -10,4 +10,5 @@
 #include "Dialog.hpp"
 
+#include "verbose.hpp"
 #include "atom.hpp"
 #include "element.hpp"
Index: src/UIElements/QT4/QTMainWindow.cpp
===================================================================
--- src/UIElements/QT4/QTMainWindow.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/UIElements/QT4/QTMainWindow.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -21,4 +21,5 @@
 #include "atom.hpp"
 #include "molecule.hpp"
+#include "verbose.hpp"
 #include "Actions/Action.hpp"
 #include "Actions/ActionRegistry.hpp"
Index: src/analysis_bonds.cpp
===================================================================
--- src/analysis_bonds.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/analysis_bonds.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -13,4 +13,5 @@
 #include "element.hpp"
 #include "info.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/analysis_correlation.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -9,4 +9,5 @@
 
 #include <iostream>
+#include <iomanip>
 
 #include "analysis_correlation.hpp"
Index: src/analysis_correlation.hpp
===================================================================
--- src/analysis_correlation.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/analysis_correlation.hpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -26,4 +26,5 @@
 
 #include "atom.hpp"
+#include "verbose.hpp"
 
 /****************************************** forward declarations *****************************/
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/analyzer.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -14,7 +14,7 @@
 #include "datacreator.hpp"
 #include "helpers.hpp"
-#include "memoryallocator.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
+#include "verbose.hpp"
 
 // include config.h
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/atom.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -12,5 +12,4 @@
 #include "element.hpp"
 #include "lists.hpp"
-#include "memoryallocator.hpp"
 #include "parser.hpp"
 #include "vector.hpp"
@@ -18,4 +17,6 @@
 #include "molecule.hpp"
 #include "Shapes/Shape.hpp"
+
+#include <iomanip>
 
 /************************************* Functions for class atom *************************************/
Index: src/atom_graphnodeinfo.cpp
===================================================================
--- src/atom_graphnodeinfo.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/atom_graphnodeinfo.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -9,5 +9,4 @@
 
 #include "atom_graphnodeinfo.hpp"
-#include "memoryallocator.hpp"
 
 /** Constructor of class GraphNodeInfo.
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/atom_particleinfo.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -9,5 +9,4 @@
 
 #include "atom_particleinfo.hpp"
-#include "memoryallocator.hpp"
 
 /** Constructor of ParticleInfo.
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/bond.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -7,4 +7,5 @@
 #include "Helpers/MemDebug.hpp"
 
+#include "verbose.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/bondgraph.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -15,4 +15,5 @@
 #include "element.hpp"
 #include "info.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/boundary.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -15,6 +15,6 @@
 #include "info.hpp"
 #include "linkedcell.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "tesselation.hpp"
@@ -24,4 +24,6 @@
 #include "Matrix.hpp"
 #include "Box.hpp"
+
+#include <iomanip>
 
 #include<gsl/gsl_poly.h>
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/builder.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -60,5 +60,4 @@
 #include "config.hpp"
 #include "log.hpp"
-#include "memoryusageobserver.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/config.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -19,7 +19,7 @@
 #include "info.hpp"
 #include "lists.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
Index: src/datacreator.cpp
===================================================================
--- src/datacreator.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/datacreator.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -12,4 +12,7 @@
 #include "helpers.hpp"
 #include "parser.hpp"
+#include "verbose.hpp"
+
+#include <iomanip>
 
 //=========================== FUNCTIONS============================
Index: src/graph.cpp
===================================================================
--- src/graph.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/graph.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -13,4 +13,5 @@
 #include "config.hpp"
 #include "graph.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
Index: src/helpers.cpp
===================================================================
--- src/helpers.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/helpers.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -8,6 +8,6 @@
 #include "helpers.hpp"
 #include "Helpers/fast_functions.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryusageobserver.hpp"
 
 /********************************************** helpful functions *********************************/
Index: src/helpers.hpp
===================================================================
--- src/helpers.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/helpers.hpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -20,5 +20,4 @@
 #include "defs.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 
 /********************************************** definitions *********************************/
Index: src/joiner.cpp
===================================================================
--- src/joiner.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/joiner.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -14,7 +14,7 @@
 #include "datacreator.hpp"
 #include "helpers.hpp"
-#include "memoryallocator.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
+#include "verbose.hpp"
 
 //============================== MAIN =============================
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/linkedcell.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -10,4 +10,5 @@
 #include "helpers.hpp"
 #include "linkedcell.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
Index: c/memoryallocator.cpp
===================================================================
--- src/memoryallocator.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ 	(revision )
@@ -1,38 +1,0 @@
-/*
- * memoryallocator.cpp
- *
- *  Created on: May 31, 2010
- *      Author: heber
- */
-
-#include "Helpers/MemDebug.hpp"
-
-using namespace std;
-
-#include "memoryallocator.hpp"
-
-/** Allocates a memory range using malloc().
- * Prints the provided error message in case of a failure.
- *
- * \param number of memory slices of type X to allocate
- * \param failure message which is printed if the allocation fails
- * \return pointer to the allocated memory range, will be NULL if a failure occurred
- */
-template <> char* Malloc<char>(size_t size, const char* output)
-{
-  char* buffer = NULL;
-  buffer = (char*) malloc(sizeof(char) * (size + 1));
-  for (size_t i = size; i--;)
-    buffer[i] = (i % 2 == 0) ? 'p': 'c';
-  buffer[size] = '\0';
-
-  if (buffer != NULL) {
-    //MemoryUsageObserver::getInstance()->addMemory(buffer, size);
-  } else {
-    Log() << Verbose(0) << "Malloc for datatype " << typeid(char).name()
-      << " failed - pointer is NULL: " << output << endl;
-  }
-
-  return buffer;
-};
-
Index: c/memoryallocator.hpp
===================================================================
--- src/memoryallocator.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ 	(revision )
@@ -1,139 +1,0 @@
-/** \file memoryallocator.hpp
- *
- * This file provides wrappers for C++'s memory allocation functions.
- */
-
-#ifndef MEMORYALLOCATOR_HPP_
-#define MEMORYALLOCATOR_HPP_
-
-using namespace std;
-
-/*********************************************** includes ***********************************/
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <cstdlib>
-#include <iostream>
-#include <iomanip>
-#include <fstream>
-#include <sstream>
-#include <math.h>
-#include <string>
-#include <typeinfo>
-
-#include "defs.hpp"
-#include "log.hpp"
-#include "memoryusageobserver.hpp"
-#include "verbose.hpp"
-
-/********************************************** declarations *******************************/
-
-/** Allocates a memory range using malloc().
- * Prints the provided error message in case of a failure.
- *
- * \param number of memory slices of type X to allocate
- * \param failure message which is printed if the allocation fails
- * \return pointer to the allocated memory range, will be NULL if a failure occurred
- */
-template <typename X> X* Malloc(size_t size, const char* output)
-{
-  X* buffer = NULL;
-  buffer = (X*) malloc(sizeof(X) * size);
-
-  if (buffer != NULL) {
-    MemoryUsageObserver::getInstance()->addMemory(buffer, size);
-  } else {
-    Log() << Verbose(0) << "Malloc for datatype " << typeid(X).name()
-      << " failed - pointer is NULL: " << output << endl;
-  }
-
-  return buffer;
-};
-
-/** \see helpers.cpp for Malloc<char> */
-template <> char* Malloc<char>(size_t size, const char* output);
-
-/* Allocates a memory range using calloc().
- * Prints the provided error message in case of a failure.
- *
- * \param number of memory slices of type X to allocate
- * \param failure message which is printed if the allocation fails
- * \return pointer to the allocated memory range, will be NULL if a failure occurred
-*/
-template <typename X> X* Calloc(size_t size, const char* output)
-{
-  X* buffer = NULL;
-  buffer = (X*) calloc(size, sizeof(X));
-
-  if (buffer != NULL) {
-    MemoryUsageObserver::getInstance()->addMemory(buffer, size);
-  } else {
-    Log() << Verbose(0) << "Calloc for datatype " << typeid(X).name()
-      << " failed - pointer is NULL: " << output << endl;
-  }
-
-  return buffer;
-};
-
-
-/** Reallocates a memory range using realloc(). If the provided pointer to the old
- * memory range is NULL, malloc() is called instead.
- * Prints the provided error message in case of a failure (of either malloc() or realloc()).
- *
- * \param pointer to the old memory range
- * \param number of memory slices of type X to allocate
- * \param failure message which is printed if the allocation fails
- * \return pointer to the reallocated memory range, will be NULL if a failure occurred
- */
-template <typename X> X* ReAlloc(X* OldPointer, size_t size, const char* output)
-{
-  X* buffer = NULL;
-  if (OldPointer == NULL) {
-    buffer = (X*) malloc(sizeof(X) * size);
-  } else {
-    buffer = (X*) realloc(OldPointer, sizeof(X) * size);
-    MemoryUsageObserver::getInstance()->removeMemory(OldPointer);
-  }
-  if (buffer != NULL) {
-    MemoryUsageObserver::getInstance()->addMemory(buffer, size);
-  } else {
-    Log() << Verbose(0) << "ReAlloc for datatype " << typeid(X).name()
-      << " failed - new is NULL: " << output << endl;
-  }
-
-  return buffer;
-};
-
-/** Frees allocated memory range using free(), NULL'ing \a **buffer.
- *
- * \param **buffer to the allocated memory range to free; may be NULL, this function is a no-op then
- * \param *msg optional error message
- */
-template <typename X> void Free(X** buffer, const char *msg = NULL)
-{
-  if ((buffer == NULL) || (*buffer == NULL))
-    return;
-
-  MemoryUsageObserver::getInstance()->removeMemory(*buffer, msg);
-  free(*buffer);
-  *buffer = NULL;
-};
-
-/** Frees allocated memory range using free() for ... * const \a buffer types.
- *
- * \param *buffer to the allocated memory range to free; may be NULL, this function is a no-op then
- * \param *msg optional error message
- */
-template <typename X> void Free(X* const buffer, const char *msg = NULL)
-{
-  if ((buffer == NULL))
-    return;
-
-  MemoryUsageObserver::getInstance()->removeMemory(buffer, msg);
-  free(buffer);
-};
-
-#endif /*MEMORYALLOCATOR_HPP_*/
Index: c/memoryusageobserver.cpp
===================================================================
--- src/memoryusageobserver.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ 	(revision )
@@ -1,126 +1,0 @@
-/*
- * \file memoryusageobserver.cpp
- *
- * This class represents a Singleton for observing memory usage.
- */
-
-#include "Helpers/MemDebug.hpp"
-
-#include <cstdlib>
-
-#include "log.hpp"
-#include "memoryusageobserver.hpp"
-#include "verbose.hpp"
-
-MemoryUsageObserver* MemoryUsageObserver::instance = NULL;
-
-/**
- * Constructor. Do not use this function. Use getInstance() instead.
- *
- * \return memory usage observer instance
- */
-MemoryUsageObserver::MemoryUsageObserver() {
-  instance = NULL;
-  maximumSize = 0;
-  totalSize = 0;
-}
-
-/**
- * Destructor. Better use purgeInstance().
- */
-MemoryUsageObserver::~MemoryUsageObserver() {
-  while (!memoryUsers.empty()) {
-    map<void*, size_t>::iterator current = memoryUsers.begin();
-    free(current->first);
-    memoryUsers.erase(current);
-  }
-
-  maximumSize = 0;
-  totalSize = 0;
-}
-
-/**
- * Returns the singleton memory usage observer instance.
- *
- * \return memory usage observer instance
- */
-MemoryUsageObserver* MemoryUsageObserver::getInstance() {
-  if (instance == NULL) {
-    instance = new MemoryUsageObserver;
-  }
-
-  return instance;
-}
-
-/**
- * Purges the current memory usage observer instance.
- */
-void MemoryUsageObserver::purgeInstance() {
-  if (instance != NULL) {
-    delete instance;
-  }
-
-  instance = NULL;
-}
-
-/**
- * Adds memory.
- *
- * \param pointer to the allocated piece of memory
- * \param size of the allocated memory
- */
-void MemoryUsageObserver::addMemory(void* pointer, size_t size) {
-  // Memory might become reseized so we need to check whether the provided pointer is already tracked.
-  map<void*, size_t>::iterator current = memoryUsers.find(pointer);
-  if (current != memoryUsers.end()) {
-    totalSize -= current->second;
-  }
-
-  memoryUsers[pointer] = size;
-  totalSize += size;
-  maximumSize = (totalSize > maximumSize) ? totalSize : maximumSize;
-}
-
-/**
- * Removes tracked memory. Prints a warning if untracked memory is to be released.
- *
- * \param pointer to the allocated piece of memory
- * \param *msg optional error message
- */
-void MemoryUsageObserver::removeMemory(void* pointer, const char *msg) {
-  map<void*, size_t>::iterator current = memoryUsers.find(pointer);
-
-  if (current == memoryUsers.end()) {
-    eLog() << Verbose(2) << "There is non-tracked memory to be freed. Pointer "
-      << pointer << " is not registered by MemoryUsageObserver: ";
-    if (msg != NULL)
-      DoLog(0) && (Log() << Verbose(0) << *msg);
-    DoLog(0) && (Log() << Verbose(0) << endl);
-    return;
-  }
-
-  totalSize -= current->second;
-  memoryUsers.erase(current);
-}
-
-/**
- * Gets the size of currently allocated memory.
- */
-size_t MemoryUsageObserver::getUsedMemorySize() {
-  return totalSize;
-}
-
-/**
- * Gets the maximum size of allocated memory until now.
- */
-size_t MemoryUsageObserver::getMaximumUsedMemory() {
-  return maximumSize;
-}
-
-/**
- * Gets a map with pointers to the currently allocated memory ranges as keys and
- * the allocated size as value.
- */
-map<void*, size_t> MemoryUsageObserver::getPointersToAllocatedMemory() {
-  return memoryUsers;
-}
Index: c/memoryusageobserver.hpp
===================================================================
--- src/memoryusageobserver.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/*
- * \file memoryusageobserver.hpp
- *
- * This class represents a Singleton for observing memory usage.
- */
-#ifndef MEMORYUSAGEOBSERVER_HPP_
-#define MEMORYUSAGEOBSERVER_HPP_
-
-using namespace std;
-
-/*********************************************** includes ***********************************/
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <map>
-#include <iostream>
-#include <iomanip>
-#include <fstream>
-#include <sstream>
-#include <math.h>
-#include <string>
-#include <typeinfo>
-
-/********************************************** declarations *******************************/
-
-class MemoryUsageObserver {
-public:
-  static MemoryUsageObserver* getInstance();
-  static void purgeInstance();
-  void addMemory(void* pointer, size_t size);
-  void removeMemory(void* pointer, const char *msg = NULL);
-  size_t getUsedMemorySize();
-  size_t getMaximumUsedMemory();
-  map<void*, size_t> getPointersToAllocatedMemory();
-
-protected:
-  /** Do not call this constructor directly, use getInstance() instead. */
-  MemoryUsageObserver();
-  /** Do not call this destructor directly, use purgeInstance() instead. */
-  ~MemoryUsageObserver();
-
-private:
-  static MemoryUsageObserver* instance;
-  map<void*, size_t> memoryUsers;
-  size_t totalSize, maximumSize;
-};
-#endif /*MEMORYUSAGEOBSERVER_HPP_*/
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -23,5 +23,5 @@
 #include "log.hpp"
 #include "molecule.hpp"
-#include "memoryallocator.hpp"
+
 #include "periodentafel.hpp"
 #include "stackclass.hpp"
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule.hpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -31,5 +31,4 @@
 #include "types.hpp"
 #include "graph.hpp"
-#include "stackclass.hpp"
 #include "tesselation.hpp"
 #include "Patterns/Observer.hpp"
@@ -54,4 +53,5 @@
 class Vector;
 class Shape;
+template <class> class StackClass;
 
 /******************************** Some definitions for easier reading **********************************/
Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule_dynamics.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -13,6 +13,6 @@
 #include "element.hpp"
 #include "info.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "parser.hpp"
Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule_fragmentation.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -17,6 +17,6 @@
 #include "helpers.hpp"
 #include "lists.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
@@ -24,4 +24,5 @@
 #include "Matrix.hpp"
 #include "Box.hpp"
+#include "stackclass.hpp"
 
 /************************************* Functions for class molecule *********************************/
Index: src/molecule_geometry.cpp
===================================================================
--- src/molecule_geometry.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule_geometry.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -14,6 +14,6 @@
 #include "helpers.hpp"
 #include "leastsquaremin.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule_graph.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -18,6 +18,6 @@
 #include "linkedcell.hpp"
 #include "lists.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
@@ -26,5 +26,5 @@
 #include "Matrix.hpp"
 #include "Box.hpp"
-
+#include "stackclass.hpp"
 
 struct BFSAccounting
Index: src/molecule_pointcloud.cpp
===================================================================
--- src/molecule_pointcloud.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/molecule_pointcloud.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -11,5 +11,4 @@
 #include "config.hpp"
 #include "info.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 
Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/moleculelist.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -19,11 +19,12 @@
 #include "linkedcell.hpp"
 #include "lists.hpp"
+#include "verbose.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
-#include "memoryallocator.hpp"
 #include "periodentafel.hpp"
 #include "Helpers/Assert.hpp"
 #include "Matrix.hpp"
 #include "Box.hpp"
+#include "stackclass.hpp"
 
 #include "Helpers/Assert.hpp"
Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/parser.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -12,6 +12,6 @@
 
 #include "helpers.hpp"
-#include "memoryallocator.hpp"
 #include "parser.hpp"
+#include "verbose.hpp"
 
 // include config.h
Index: src/stackclass.hpp
===================================================================
--- src/stackclass.hpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/stackclass.hpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -12,5 +12,5 @@
 
 #include "verbose.hpp"
-#include "memoryallocator.hpp"
+#include "log.hpp"
 
 /****************************************** forward declarations *****************************/
Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/tesselation.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -9,4 +9,5 @@
 
 #include <fstream>
+#include <iomanip>
 
 #include "helpers.hpp"
Index: src/triangleintersectionlist.cpp
===================================================================
--- src/triangleintersectionlist.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/triangleintersectionlist.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -16,4 +16,5 @@
 #include "tesselation.hpp"
 #include "vector.hpp"
+#include "verbose.hpp"
 
 /** Constructor for class TriangleIntersectionList.
Index: src/unittests/ActOnAllUnitTest.cpp
===================================================================
--- src/unittests/ActOnAllUnitTest.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/unittests/ActOnAllUnitTest.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -14,5 +14,4 @@
 #include "../test/ActOnAlltest.hpp"
 #include "ActOnAllUnitTest.hpp"
-#include "memoryallocator.hpp"
 #include "vector.hpp"
 
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/unittests/Makefile.am	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -31,6 +31,4 @@
   LogUnitTest \
   manipulateAtomsTest \
-  MemoryUsageObserverUnitTest \
-  MemoryAllocatorUnitTest \
   MoleculeDescriptorTest \
   ObserverTest \
@@ -77,6 +75,4 @@
   logunittest.cpp \
   manipulateAtomsTest.cpp \
-  memoryallocatorunittest.cpp  \
-  memoryusageobserverunittest.cpp \
   MoleculeDescriptorTest.cpp \
   ObserverTest.cpp \
@@ -114,6 +110,4 @@
   logunittest.hpp \
   manipulateAtomsTest.hpp \
-  memoryallocatorunittest.hpp  \
-  memoryusageobserverunittest.hpp \
   MoleculeDescriptorTest.hpp \
   periodentafelTest.hpp \
@@ -191,10 +185,4 @@
 manipulateAtomsTest_LDADD = ${ALLLIBS}
 
-MemoryAllocatorUnitTest_SOURCES = UnitTestMain.cpp ../memoryallocator.hpp ../memoryallocator.cpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp memoryallocatorunittest.cpp memoryallocatorunittest.hpp 
-MemoryAllocatorUnitTest_LDADD = ${ALLLIBS}
-
-MemoryUsageObserverUnitTest_SOURCES = UnitTestMain.cpp ../memoryallocator.hpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp memoryusageobserverunittest.cpp memoryusageobserverunittest.hpp 
-MemoryUsageObserverUnitTest_LDADD = ${ALLLIBS}
-
 MoleculeDescriptorTest_SOURCES = UnitTestMain.cpp MoleculeDescriptorTest.cpp MoleculeDescriptorTest.hpp
 MoleculeDescriptorTest_LDADD = ${ALLLIBS}
@@ -230,5 +218,5 @@
 Tesselation_InOutsideUnitTest_LDADD = ${ALLLIBS}
 
-TestRunner_SOURCES = TestRunnerMain.cpp ../memoryallocator.hpp ../memoryallocator.cpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp $(TESTSOURCES) $(TESTHEADERS)
+TestRunner_SOURCES = TestRunnerMain.cpp $(TESTSOURCES) $(TESTHEADERS)
 TestRunner_LDADD = ${ALLLIBS}
 
Index: src/unittests/tesselation_insideoutsideunittest.cpp
===================================================================
--- src/unittests/tesselation_insideoutsideunittest.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/unittests/tesselation_insideoutsideunittest.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -17,4 +17,5 @@
 #include "tesselation.hpp"
 #include "tesselation_insideoutsideunittest.hpp"
+#include "verbose.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/vectorunittest.cpp
===================================================================
--- src/unittests/vectorunittest.cpp	(revision 5ec8e3b251db03ba84a62d656f8f84526948e941)
+++ src/unittests/vectorunittest.cpp	(revision 36166d0baeb554d5194ca8550fe89d2ea46ca643)
@@ -15,5 +15,4 @@
 #include "defs.hpp"
 #include "log.hpp"
-#include "memoryusageobserver.hpp"
 #include "vector.hpp"
 #include "vector_ops.hpp"