Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 554809007e3b5cc0682e8fb20aec965cd247193f)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 38032a2bcd60a9243123e7c23376316197727fc9)
@@ -7,4 +7,5 @@
 WORKERPORT=1035
 CONTROLLERPORT=1036
+LISTENPORT=1037
 
 # start service in background
@@ -18,5 +19,5 @@
 
 # work on jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Worker 127.0.0.1 $WORKERPORT], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker 127.0.0.1 $WORKERPORT 127.0.0.1 $LISTENPORT], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 554809007e3b5cc0682e8fb20aec965cd247193f)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 38032a2bcd60a9243123e7c23376316197727fc9)
@@ -7,4 +7,5 @@
 WORKERPORT=1050
 CONTROLLERPORT=1051
+LISTENPORT=1052
 
 # start service in background
@@ -22,6 +23,6 @@
 AT_CHECK([fgrep "0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 # start working
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Worker 127.0.0.1 $WORKERPORT], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Calculating job #1" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker 127.0.0.1 $WORKERPORT 127.0.0.1 $LISTENPORT], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "result #1 sent" stdout], 0, [ignore], [ignore], [kill $server_pid])
 # Checking results 
 AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid])
@@ -33,6 +34,6 @@
 AT_CHECK([grep "1" stdout], 0, [ignore], [ignore], [kill $server_pid])
 # work some more
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Worker 127.0.0.1 $WORKERPORT], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Calculating job #2" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker 127.0.0.1 $WORKERPORT 127.0.0.1 $LISTENPORT], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "result #2 sent" stdout], 0, [ignore], [ignore], [kill $server_pid])
 # Checking results 
 AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid])
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 554809007e3b5cc0682e8fb20aec965cd247193f)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 38032a2bcd60a9243123e7c23376316197727fc9)
@@ -7,4 +7,5 @@
 WORKERPORT=1025
 CONTROLLERPORT=1026
+LISTENPORT=1027
 
 # start service in background
@@ -17,6 +18,6 @@
 
 # first worker has a job
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Worker 127.0.0.1 $WORKERPORT], 0, [stdout], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "Job id: 1" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker 127.0.0.1 $WORKERPORT 127.0.0.1 $LISTENPORT], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "result #1 sent" stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # check number of done jobs 