Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision f6ba43405488e9595322b8bef96c7c7fb1191d67)
+++ src/Actions/Makefile.am	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
@@ -230,13 +230,16 @@
   Actions/ParserAction/ParseTremoloPotentialsAction.cpp \
   Actions/ParserAction/SetMpqcParametersAction.cpp \
-  Actions/ParserAction/SetOutputFormatsAction.cpp
+  Actions/ParserAction/SetOutputFormatsAction.cpp \
+  Actions/ParserAction/SetTremoloAtomdataAction.cpp
 PARSERACTIONHEADER = \
   Actions/ParserAction/ParseTremoloPotentialsAction.hpp \
   Actions/ParserAction/SetMpqcParametersAction.hpp \
-  Actions/ParserAction/SetOutputFormatsAction.hpp               
+  Actions/ParserAction/SetOutputFormatsAction.hpp \
+  Actions/ParserAction/SetTremoloAtomdataAction.hpp
 PARSERACTIONDEFS = \
   Actions/ParserAction/ParseTremoloPotentialsAction.def \
   Actions/ParserAction/SetMpqcParametersAction.def \
-  Actions/ParserAction/SetOutputFormatsAction.def               
+  Actions/ParserAction/SetOutputFormatsAction.def \
+  Actions/ParserAction/SetTremoloAtomdataAction.def
 
 RANDONNUMBERSSOURCE =\
Index: src/Actions/ParserAction/SetTremoloAtomdataAction.cpp
===================================================================
--- src/Actions/ParserAction/SetTremoloAtomdataAction.cpp	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
+++ src/Actions/ParserAction/SetTremoloAtomdataAction.cpp	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
@@ -0,0 +1,74 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * SetTremoloAtomdataAction.cpp
+ *
+ *  Created on: Aug 9, 2011
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Parser/TremoloParser.hpp"
+#include "Parser/FormatParserStorage.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+#include <iostream>
+#include <string>
+
+#include <boost/filesystem/fstream.hpp>
+
+using namespace std;
+
+#include "SetTremoloAtomdataAction.hpp"
+
+// and construct the stuff
+#include "SetTremoloAtomdataAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr ParserSetTremoloAtomdataAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
+
+  TremoloParser &tremolo = FormatParserStorage::getInstance().getTremolo();
+
+  DoLog(1) && (Log() << Verbose(1) << "Setting Tremolo's ATOMDATA to: '" << params.atomdata_string << "'" << std::endl);
+
+  tremolo.setAtomData(params.atomdata_string);
+
+  return Action::success;
+}
+
+Action::state_ptr ParserSetTremoloAtomdataAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr ParserSetTremoloAtomdataAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool ParserSetTremoloAtomdataAction::canUndo() {
+  return false;
+}
+
+bool ParserSetTremoloAtomdataAction::shouldUndo() {
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/ParserAction/SetTremoloAtomdataAction.def
===================================================================
--- src/Actions/ParserAction/SetTremoloAtomdataAction.def	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
+++ src/Actions/ParserAction/SetTremoloAtomdataAction.def	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
@@ -0,0 +1,33 @@
+/*
+ * SetTremoloAtomdataAction.def
+ *
+ *  Created on: Feb 9, 2011
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include <boost/filesystem.hpp>
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (std::string)
+#define paramtokens ("set-tremolo-atomdata")
+#define paramdescriptions ("properties to set, space-separated")
+#undef paramdefaults
+#define paramreferences (atomdata_string)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Parser
+#define MENUNAME "parser"
+#define MENUPOSITION 12
+#define ACTIONNAME SetTremoloAtomdata
+#define TOKEN "set-tremolo-atomdata"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "sets the properties per atom line to write to tremolo data file"
+#undef SHORTFORM
Index: src/Actions/ParserAction/SetTremoloAtomdataAction.hpp
===================================================================
--- src/Actions/ParserAction/SetTremoloAtomdataAction.hpp	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
+++ src/Actions/ParserAction/SetTremoloAtomdataAction.hpp	(revision 064178f528b483f670f19f89ffe6723a2f46d988)
@@ -0,0 +1,22 @@
+/*
+ * SetTremoloAtomdataAction.hpp
+ *
+ *  Created on: Aug 9, 2011
+ *      Author: heber
+ */
+
+#ifndef SETTREMOLOATOMDATAACTION_HPP_
+#define SETTREMOLOATOMDATAACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "SetTremoloAtomdataAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* SETTREMOLOATOMDATAACTION_HPP_ */